Require Import List.

(** * Facts about [app] *)

Lemma app_cons: 
  forall (A:Type)(l:list A)(a:A), 
    a::l = (a::nil) ++ l.
Proof.
  intros A l.
  induction l. 
  reflexivity.
  rewrite IHl. reflexivity.
Qed.


(* To be removed, is solve by firstorder *)
Lemma inAppCons:
  forall (A:Type)(l1 l2:list A)(a:A),
    In a (l1++a::l2).
Proof.
  intros A l1 l2 a.
  apply in_app_iff; right; simpl; left; reflexivity.
Qed.


  
Lemma app_l_l'_nil : forall A (l l' : list A), l = l++l' -> l'=nil.
  intros A.
  induction l. intros; simpl in H; symmetry; auto.
  intros.
  simpl in H. injection H. intro H'; rewrite <- H' in *. apply IHl. assumption.
Qed.
